=== modified file 'testweave.py'
--- testweave.py	2005-06-28 09:21:30 +0000
+++ testweave.py	2005-06-28 09:27:28 +0000
@@ -161,6 +161,26 @@
 
 
 
+class SuicideDelete(TestBase):
+    def runTest(self):
+        k = Weave()
+
+        k._v = [VerInfo([]),
+                ]
+        k._l = [('{', 0),
+                'first line',
+                ('[', 0),
+                'deleted in 0',
+                (']', 0),
+                ('}', 0),
+                ]
+
+        self.assertRaises(WeaveFormatError,
+                          k.get,
+                          0)        
+
+
+
 class CannedDelete(TestBase):
     """Unpack canned weave with deleted lines."""
     def runTest(self):

=== modified file 'weave.py'
--- weave.py	2005-06-28 09:21:30 +0000
+++ weave.py	2005-06-28 09:27:28 +0000
@@ -102,6 +102,11 @@
     * Lines are enabled if the most recent enclosing insertion is
       active and none of the enclosing deletions are active.
 
+    * There is no point having a deletion directly inside its own
+      insertion; you might as well just not write it.  And there
+      should be no way to get an earlier version deleting a later
+      version.
+
 
     _l
         Text of the weave. 
@@ -245,7 +250,10 @@
                     if v in dset:
                         raise WeaveFormatError("repeated deletion marker for version %d on line %d"
                                                % (v, lineno))
-                    else:
+                    if istack:
+                        if istack[-1] == v:
+                            raise WeaveFormatError("version %d deletes own text on line %d"
+                                                   % (v, lineno))
                         dset.add(v)
                 elif c == ']':
                     if v in dset:

